/*! \file
"Character Strip" class  -- 99:4:13
(commented 2003:3:23)
*/

#ifndef CSTRIP__H_
#define CSTRIP__H_

#ifndef INFINITY
  #define	INFINITY	0x7FFFFFFFL
#endif

#define CSTRIP_EOF -1
#define CSTRIP_ERROR -2

/*!	A base class to provide a continuous sequence of 16-bit character
	codes ('Unicode') from some source -- dependent on the actual derived class.
	(It's not a virtual class, but all the methods are dummies...)
	
	The (unsigned) 16-bit values are passed as signed integers
	as eof & errors are negative.  Null is a possible valid character,
	but code may not (yet) handle it.
*/
class Cstrip {
  public:
	Cstrip() {};
	virtual ~Cstrip() {};
	//! Return the current character code and increment the current position 
	virtual int get() {return CSTRIP_ERROR;}
	//! Return the current character code without changing position 
	virtual int look() {return CSTRIP_ERROR;}
	//! Return the current position (starts at 0) 
	virtual long pos(){return CSTRIP_ERROR;}
	//! Set the current position 
	virtual bool pos(long p) {return false;}
	//! Return the lowest guaranteed available position 
	virtual long lowBound(){return CSTRIP_ERROR;}
	//! Set the lowest position that may be still required 
	virtual bool lowBound(long p) {return false;}
	// ... more to come, I'm sure
};

#endif //CSTRIP__H_
