// Basic "Text Strip" -- UTF/8-bit switchable -- derived from Cstrip
// 2003:3:2

#include <string.h>
#include <stdio.h>
#include "utfstrip.h"
#include "utfutil.h"


#ifdef	RXDEBUG
 #define DPRINTF(s) printf s
 char * iname(int t);
#else
 #define DPRINTF(s)
#endif

// for temporary quick-checks...
// Always on:
#define XDPRINTF(s) printf s
// Always off:
#define ZDPRINTF(s)

////////////////////////////////////////////////////////////////////////

UtfStrip::UtfStrip(char * s, bool utf) : useutf(utf),
	text(s), cptr(s), lowbound(0), cpos(0) {
	if (useutf) striplen = utflen(text);
	else striplen = strlen(text);
}

UtfStrip::~UtfStrip()
{
	// do nothing at the moment
}


int UtfStrip::get()
{
	if (!text || !*cptr) return CSTRIP_EOF;
	cpos++;
	DPRINTF(("UtfStrip get %d\n", cpos);)
	return useutf? utf2istep(cptr) : (*cptr++ & 0xFF);
}

int UtfStrip::look()
{
	if (!text || !*cptr) return CSTRIP_EOF;
	DPRINTF(("UtfStrip look %d\n", cpos);)
	return useutf? utf2i(cptr) : (*cptr & 0xFF);
}


long UtfStrip::pos()
{
	return text? cpos : CSTRIP_ERROR;
}


bool UtfStrip::pos(long p)
{
	DPRINTF(("trying to set UtfStrip pos %d\n", p);)
	if (text && p >= 0 && p < striplen) cpos = p;
	else return false;
	if (useutf) {
		cptr = text;
		utfstep(cptr, p);
	} else cptr = text+p;
	return true;
}


long UtfStrip::lowBound()
{
	return lowbound;
}


bool UtfStrip::lowBound(long p)
{
	DPRINTF(("setting lowbound = %d\n", p);)
	if (text && p > 0 && p < striplen) lowbound = p;
	else return false;
	return true;
}


